package ru.octol1ttle.knockdowns.client.event;

import java.util.HashMap;
import java.util.Map;
import java.util.function.Supplier;
import net.minecraft.client.Minecraft;
import net.minecraft.client.settings.KeyBinding;
import net.minecraftforge.fml.client.registry.ClientRegistry;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import org.lwjgl.input.Keyboard;
import ru.octol1ttle.knockdowns.Tags;
import ru.octol1ttle.knockdowns.common.communication.CalloutType;
import ru.octol1ttle.knockdowns.common.data.IKnockdownsPlayerData;
import ru.octol1ttle.knockdowns.common.network.KnockdownsNetwork;
import ru.octol1ttle.knockdowns.common.network.packets.c2s.PlayerCalloutC2SPacket;

@SideOnly(Side.CLIENT)
@Mod.EventBusSubscriber(value = Side.CLIENT, modid = Tags.MOD_ID)
public class KnockdownsKeyListener {
    private static final Minecraft client = Minecraft.getMinecraft();
    public static final Map<KeyBinding, Supplier<CalloutType>> calloutBindings = new HashMap<>();

    public static void registerKeyBindings() {
        calloutBindings.put(
                new KeyBinding("knockdowns.key.callout.danger", Keyboard.KEY_LEFT, "knockdowns.key.category"),
                () -> CalloutType.DANGER
        );
        calloutBindings.put(
                new KeyBinding("knockdowns.key.callout.booyah", Keyboard.KEY_DOWN, "knockdowns.key.category"),
                () -> CalloutType.BOOYAH
        );
        calloutBindings.put(
                new KeyBinding("knockdowns.key.callout.this_way_help", Keyboard.KEY_UP, "knockdowns.key.category"),
                () -> IKnockdownsPlayerData.get(client.player).isKnockedDown() ? CalloutType.HELP : CalloutType.THIS_WAY
        );
        calloutBindings.put(
                new KeyBinding("knockdowns.key.callout.ouch", Keyboard.KEY_RIGHT, "knockdowns.key.category"),
                () -> CalloutType.OUCH
        );

        for (KeyBinding binding : calloutBindings.keySet()) {
            ClientRegistry.registerKeyBinding(binding);
        }
    }

    public static void tickKeys() {
        for (KeyBinding binding : calloutBindings.keySet()) {
            if (binding.isPressed()) {
                KnockdownsNetwork.sendToServer(new PlayerCalloutC2SPacket(calloutBindings.get(binding).get()));
                break;
            }
        }
    }
}
