package ru.octol1ttle.knockdowns.client.gui;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.Entity;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.math.Vec3d;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import org.lwjgl.opengl.GL11;
import ru.octol1ttle.knockdowns.Tags;
import ru.octol1ttle.knockdowns.client.communication.KnockedNotificationManager;
import ru.octol1ttle.knockdowns.client.util.KnockedPlayerData;

@SideOnly(Side.CLIENT)
public class KnockedNotificationGui extends KnockdownsBaseGui {
    private static final Minecraft client = Minecraft.getMinecraft();
    private static final int KNOCKED_ICON_SIZE = 18;
    private static final ResourceLocation KNOCKED_ICON = new ResourceLocation(Tags.MOD_ID, "textures/gui/knocked_icon.png");
    private float totalPartialTicks;

    @Deprecated
    @Override
    public void render(float partialTicks, ScaledResolution resolution) {
    }

    public void renderNotifications(float partialTicks) {
        totalPartialTicks += partialTicks;
        for (KnockedPlayerData data : KnockedNotificationManager.getKnockedPlayerDatas()) {
            Entity entity = client.world.getEntityByID(data.getPlayerId());
            renderKnockedNotification(
                    entity != null ? entity.getPositionEyes(partialTicks).add(0, 1, 0) : data.getPosition(),
                    client.getRenderManager().playerViewX,
                    client.getRenderManager().playerViewY,
                    client.getRenderManager().options.thirdPersonView == 2
            );
        }
    }

    private void renderKnockedNotification(Vec3d position, float pitch, float yaw, boolean isThirdPersonFrontal) {
        Vec3d deltaPos = position.subtract(client.getRenderManager().viewerPosX, client.getRenderManager().viewerPosY, client.getRenderManager().viewerPosZ);

        GlStateManager.pushMatrix();
        GlStateManager.translate(deltaPos.x, deltaPos.y, deltaPos.z);
        GlStateManager.rotate(-yaw, 0.0F, 1.0F, 0.0F);
        GlStateManager.rotate((float)(isThirdPersonFrontal ? -1 : 1) * pitch, 1.0F, 0.0F, 0.0F);
        float scale = (float) Math.max(deltaPos.length() / 8.0f, 1.0f) * (0.75f + MathHelper.abs((float) (MathHelper.sin(totalPartialTicks / 10F) / Math.PI)));
        GlStateManager.scale(0.05F * scale, 0.05F * scale, 0.05F * scale);
        GlStateManager.color(1f, 1f, 1f, 1f);
        GlStateManager.disableCull();
        GlStateManager.depthFunc(GL11.GL_ALWAYS);

        client.getTextureManager().bindTexture(KNOCKED_ICON);
        this.drawTexture(
                -KNOCKED_ICON_SIZE / 2,
                -KNOCKED_ICON_SIZE / 2,
                KNOCKED_ICON_SIZE,
                KNOCKED_ICON_SIZE
        );

        GlStateManager.depthFunc(GL11.GL_LEQUAL);
        GlStateManager.enableCull();
        GlStateManager.popMatrix();
    }
}
