package ru.octol1ttle.knockdowns.common.data;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;
import ru.octol1ttle.knockdowns.common.KnockdownsUtils;
import ru.octol1ttle.knockdowns.common.util.UniqueOnlyList;

public class KnockdownsPlayerData implements IKnockdownsPlayerData {
    private static final String KEY_KNOCKED_DOWN = "KnockedDown";
    private static final String KEY_REVIVE_TIME_LEFT = "ReviveTimeLeft";
    private static final String KEY_TICKS_KNOCKED = "TicksKnocked";
    private boolean knockedDown = false;
    private int reviveTimeLeft = KnockdownsUtils.INITIAL_REVIVE_TIME_LEFT;
    private int ticksKnocked = 0;
    private final UniqueOnlyList<EntityPlayer> revivers = new UniqueOnlyList<>();

    @Override
    public boolean isKnockedDown() {
        return this.knockedDown;
    }

    @Override
    public void setKnockedDown(boolean knockedDown) {
        this.knockedDown = knockedDown;
    }

    @Override
    public int getReviveTimeLeft() {
        return this.reviveTimeLeft;
    }

    @Override
    public void setReviveTimeLeft(int reviveTimeLeft) {
        this.reviveTimeLeft = reviveTimeLeft;
    }

    @Override
    public int getTicksKnocked() {
        return this.ticksKnocked;
    }

    @Override
    public void setTicksKnocked(int ticksKnocked) {
        this.ticksKnocked = ticksKnocked;
    }

    @Override
    public UniqueOnlyList<EntityPlayer> getRevivers() {
        return revivers;
    }

    @Override
    public NBTTagCompound serializeNBT() {
        NBTTagCompound nbt = new NBTTagCompound();
        nbt.setBoolean(KEY_KNOCKED_DOWN, this.knockedDown);
        nbt.setInteger(KEY_REVIVE_TIME_LEFT, this.reviveTimeLeft);
        nbt.setInteger(KEY_TICKS_KNOCKED, this.ticksKnocked);
        return nbt;
    }

    @Override
    public void deserializeNBT(NBTTagCompound nbt) {
        this.knockedDown = nbt.getBoolean(KEY_KNOCKED_DOWN);
        this.reviveTimeLeft = nbt.getInteger(KEY_REVIVE_TIME_LEFT);
        this.ticksKnocked = nbt.getInteger(KEY_TICKS_KNOCKED);
    }
}
