package ru.octol1ttle.knockdowns.common.mixins;

import com.llamalad7.mixinextras.injector.ModifyReturnValue;
import net.minecraft.entity.player.EntityPlayer;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import ru.octol1ttle.knockdowns.common.data.IKnockdownsPlayerData;

@SuppressWarnings("ConstantValue")
@Mixin(EntityPlayer.class)
public class EntityPlayerMixin {
    @ModifyReturnValue(method = "shouldHeal", at = @At("RETURN"))
    private boolean dontHealIfKnockedDown(boolean original) {
        if (((Object) this) instanceof EntityPlayer) {
            EntityPlayer player = (EntityPlayer) (Object) this;
            if (IKnockdownsPlayerData.get(player).isKnockedDown()) {
                return false;
            }
        }
        return original;
    }
}
