package ru.octol1ttle.knockdowns.common.network.packets.s2c;

import io.netty.buffer.ByteBuf;
import net.minecraft.util.math.Vec3d;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import ru.octol1ttle.knockdowns.common.communication.CalloutType;

public class PlayerCalloutS2CPacket implements IMessage {
    public PlayerCalloutS2CPacket() {
    }

    public int playerId;
    public Vec3d position;
    public CalloutType type;

    public PlayerCalloutS2CPacket(int playerId, Vec3d position, CalloutType type) {
        this.playerId = playerId;
        this.position = position;
        this.type = type;
    }

    @Override
    public void toBytes(ByteBuf buf) {
        buf.writeInt(this.playerId);
        buf.writeDouble(this.position.x);
        buf.writeDouble(this.position.y);
        buf.writeDouble(this.position.z);
        buf.writeByte(this.type.getId());
    }

    @Override
    public void fromBytes(ByteBuf buf) {
        this.playerId = buf.readInt();
        this.position = new Vec3d(buf.readDouble(), buf.readDouble(), buf.readDouble());
        this.type = CalloutType.byId(buf.readByte());
    }
}
