package ru.octol1ttle.knockdowns.common.network.packets.s2c;

import io.netty.buffer.ByteBuf;
import net.minecraft.util.math.Vec3d;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;

public class PlayerKnockedDownS2CPacket implements IMessage {
    public PlayerKnockedDownS2CPacket() {
    }

    public int playerId;
    public int dimensionId;
    public Vec3d position;

    public PlayerKnockedDownS2CPacket(int playerId, int dimensionId, Vec3d position) {
        this.playerId = playerId;
        this.dimensionId = dimensionId;
        this.position = position;
    }

    @Override
    public void toBytes(ByteBuf buf) {
        buf.writeInt(this.playerId);
        buf.writeInt(this.dimensionId);
        buf.writeDouble(this.position.x);
        buf.writeDouble(this.position.y);
        buf.writeDouble(this.position.z);
    }

    @Override
    public void fromBytes(ByteBuf buf) {
        this.playerId = buf.readInt();
        this.dimensionId = buf.readInt();
        this.position = new Vec3d(buf.readDouble(), buf.readDouble(), buf.readDouble());
    }
}
