package ru.octol1ttle.knockdowns.common.network.packets.s2c;

import io.netty.buffer.ByteBuf;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;

public class SynchronizeReviversS2CPacket {
    public static class Add implements IMessage {
        public Add() {
        }

        public int knockedId;
        public int reviverId;

        public Add(int knockedId, int reviverId) {
            this.knockedId = knockedId;
            this.reviverId = reviverId;
        }

        @Override
        public void toBytes(ByteBuf buf) {
            buf.writeInt(this.knockedId);
            buf.writeInt(this.reviverId);
        }

        @Override
        public void fromBytes(ByteBuf buf) {
            this.knockedId = buf.readInt();
            this.reviverId = buf.readInt();
        }
    }

    public static class Remove implements IMessage {
        public Remove() {
        }

        public int knockedId;
        public int reviverId;

        public Remove(int knockedId, int reviverId) {
            this.knockedId = knockedId;
            this.reviverId = reviverId;
        }

        @Override
        public void toBytes(ByteBuf buf) {
            buf.writeInt(this.knockedId);
            buf.writeInt(this.reviverId);
        }

        @Override
        public void fromBytes(ByteBuf buf) {
            this.knockedId = buf.readInt();
            this.reviverId = buf.readInt();
        }
    }
}
